> ## Documentation Index
> Fetch the complete documentation index at: https://docs.dfns.co/llms.txt
> Use this file to discover all available pages before exploring further.

# Submit Genesis Output

#### Authentication

✅ Organization User (`CustomerEmployee`)\
❌ Delegated User (`EndUser`)\
✅ Service Account

#### Required Permissions

`KeyStores:Fleets:Create`: Always required.


## OpenAPI

````yaml /openapi.yaml post /key-stores/{storeId}/genesis/output
openapi: 3.1.0
info:
  version: 1.891.1
  title: Dfns
servers:
  - url: https://api.dfns.io
    description: Default - Europe
  - url: https://api.uae.dfns.io
    description: UAE
  - url: https://api.dfns.ninja
    description: <Deprecated> Staging
security: []
paths:
  /key-stores/{storeId}/genesis/output:
    post:
      tags:
        - Signers
      summary: Submit Genesis Output
      parameters:
        - schema:
            type: string
            minLength: 1
          required: true
          name: storeId
          in: path
      requestBody:
        required: true
        content:
          multipart/form-data:
            schema:
              type: object
              properties:
                data:
                  type: object
                  properties:
                    fileChecksum:
                      type: string
                      pattern: ^[a-f0-9]{64}$
                    outputJson:
                      type: object
                      properties:
                        type:
                          type: string
                          enum:
                            - fleet-output
                        version:
                          type: number
                          enum:
                            - 1
                        status:
                          type: string
                          enum:
                            - success
                        org_id:
                          type: string
                          minLength: 1
                        fleet_id:
                          type: string
                          minLength: 1
                        fleet_label:
                          type: string
                          minLength: 1
                        keystore_id:
                          type: string
                          minLength: 1
                        group_id:
                          type: string
                          minLength: 1
                        online_domain:
                          type: string
                          minLength: 1
                        governance:
                          type: object
                          additionalProperties: {}
                        outputs:
                          type: object
                          additionalProperties:
                            type: object
                            properties:
                              success:
                                oneOf:
                                  - type: object
                                    properties:
                                      type:
                                        type: string
                                        enum:
                                          - genesis-registration
                                      ceremony_mode:
                                        type: string
                                        minLength: 1
                                      hsm_serial:
                                        type: string
                                        minLength: 1
                                      hsm_identity_key:
                                        type: string
                                        pattern: ^[a-f0-9]+$
                                      mac_serial:
                                        type: string
                                        minLength: 1
                                      mac_se_wrap_key_pub_key:
                                        type: string
                                        minLength: 1
                                      provisioners:
                                        type: object
                                        additionalProperties:
                                          type: string
                                      hsm_sealed: {}
                                      key_harvest:
                                        type: object
                                        properties:
                                          ed25519-start:
                                            type: integer
                                            minimum: 0
                                          ed25519:
                                            type: integer
                                            minimum: 0
                                          error:
                                            type:
                                              - string
                                              - 'null'
                                          secp256k1-start:
                                            type: integer
                                            minimum: 0
                                          secp256k1:
                                            type: integer
                                            minimum: 0
                                        required:
                                          - ed25519-start
                                          - ed25519
                                          - error
                                          - secp256k1-start
                                          - secp256k1
                                    required:
                                      - type
                                      - hsm_serial
                                      - hsm_identity_key
                                      - mac_serial
                                      - mac_se_wrap_key_pub_key
                                      - provisioners
                                      - key_harvest
                                    title: Genesis Registration
                                  - type: object
                                    properties:
                                      type:
                                        type: string
                                        enum:
                                          - clone-registration
                                      ceremony_mode:
                                        type: string
                                        minLength: 1
                                      hsm_target_serial:
                                        type: string
                                        minLength: 1
                                      hsm_identity_key:
                                        type: string
                                        pattern: ^[a-f0-9]+$
                                      mac_target_serial:
                                        type: string
                                        minLength: 1
                                      mac_se_wrap_key_pub_key:
                                        type: string
                                        minLength: 1
                                      hsm_sealed: {}
                                    required:
                                      - type
                                      - hsm_target_serial
                                      - hsm_identity_key
                                      - mac_target_serial
                                      - mac_se_wrap_key_pub_key
                                    title: Clone Registration
                                  - type: object
                                    properties:
                                      type:
                                        type: string
                                        enum:
                                          - add-mac-user
                                      ceremony_mode:
                                        type: string
                                        minLength: 1
                                      hsm_target_serial:
                                        type: string
                                        minLength: 1
                                      hsm_identity_key:
                                        type: string
                                        pattern: ^[a-f0-9]+$
                                      mac_target_serial:
                                        type: string
                                        minLength: 1
                                      mac_username:
                                        type: string
                                        minLength: 1
                                      mac_se_wrap_key_pub_key:
                                        type: string
                                        minLength: 1
                                      hsm_sealed: {}
                                    required:
                                      - type
                                      - hsm_target_serial
                                      - hsm_identity_key
                                      - mac_target_serial
                                      - mac_se_wrap_key_pub_key
                                    title: Add Mac User Registration
                            required:
                              - success
                      required:
                        - type
                        - version
                        - status
                        - org_id
                        - fleet_id
                        - fleet_label
                        - keystore_id
                        - group_id
                        - online_domain
                        - outputs
                  required:
                    - fileChecksum
                    - outputJson
                file:
                  type: string
                  format: binary
              required:
                - data
                - file
      responses:
        '200':
          description: Success
          content:
            application/json:
              schema:
                type: object
                properties:
                  message:
                    type: string
                required:
                  - message
      security:
        - authenticationToken: []
          userActionSignature: []
components:
  securitySchemes:
    authenticationToken:
      type: http
      scheme: bearer
      bearerFormat: JWT
      description: >-
        **Bearer Token:** Used to authenticate API requests.

        More details how to generate the token: [Authentication
        flows](https://docs.dfns.co/api-reference/auth/login-flows)
    userActionSignature:
      type: apiKey
      in: header
      name: X-DFNS-USERACTION
      description: >-
        **User Action Signature:** Used to sign the change-inducing API
        requests.

        More details how to generate the token: [User Action Signing
        flows](https://docs.dfns.co/api-reference/auth/signing-flows)

````